#!/usr/bin/env ruby 
#
# kdc - Keyboard Distance Count

def diff(a, b)
  if a > b
    return a - b
  else
    return b - a
  end
end

h = {
  "1" => [0,0],
  "2" => [1,0],
  "3" => [2,0],
  "4" => [3,0],
  "5" => [4,0],
  "6" => [5,0],
  "7" => [6,0],
  "8" => [7,0],
  "9" => [8,0],
  "0" => [9,0],
  "!" => [0,0],
  "@" => [1,0],
  "#" => [2,0],
  "$" => [3,0],
  "%" => [4,0],
  "^" => [5,0],
  "&" => [6,0],
  "*" => [7,0],
  "(" => [8,0],
  ")" => [9,0],
  "-" => [10,0],
  "_" => [10,0],
  "=" => [11,0],
  "+" => [11,0],
  "a" => [0,2],
  "b" => [4,3],
  "c" => [2,3],
  "d" => [2,2],
  "e" => [2,1],
  "f" => [3,2],
  "g" => [4,2],
  "h" => [5,2],
  "i" => [7,1],
  "j" => [6,2],
  "k" => [7,2],
  "l" => [8,2],
  "m" => [6,3],
  "n" => [5,3],
  "o" => [8,1],
  "p" => [9,2],
  "q" => [0,0],
  "r" => [3,1],
  "s" => [1,2],
  "t" => [4,1],
  "u" => [6,1],
  "v" => [4,3],
  "w" => [1,0],
  "x" => [1,3],
  "y" => [5,1],
  "z" => [0,3],
  ";" => [9,2],
  ":" => [9,2],
  "'" => [10,2],
  "," => [7,3],
  "<" => [7,3],
  "." => [8,3],
  ">" => [8,3],
  "/" => [9,3],
  "?" => [9,3],
  "`" => [-1,0],
  "~" => [-1,0]
}

if ARGV.size < 1
  puts "Need an argument"
  exit(0)
end

str = ARGV[0].downcase

res = []
total = 0
0.upto(str.length-1) { |i|
  next if i == 0
  char = str[i].chr
  pchar = str[i-1].chr
  
  char = '1' unless h.has_key?("#{char}")
  pchar = '1' unless h.has_key?("#{pchar}")

#  puts "char: #{char}, pchar: #{pchar}"
  cx = h["#{char}"][0]
  cy = h["#{char}"][1]
  px = h["#{pchar}"][0]
  py = h["#{pchar}"][1]
  xd = diff(cx,px)
  yd = diff(cy,py)
#  puts "xd: #{xd}, yd: #{yd}"
  res.push(xd + yd)
  total += (xd + yd)
}

print "#{total},"

0.upto(res.length-1) { |i|
  print res[i]
  print "-" unless i+1 == res.length
}
print "\n"

